#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "BinTree.h"

void showkey(TreeEntry);
void showentry(TreeEntry);


int main()
{
  Tree arv, arv1;


  arv=CreateTree();
  arv=InsertTree(arv,7,"Braga");
  arv=InsertTree(arv,9,"Porto");
  arv=InsertTree(arv,3,"Lisboa");
  arv=InsertTree(arv,5,"Evora");
  arv=InsertTree(arv,8,"Viseu");
  arv=InsertTree(arv,4,"Faro");
  arv=InsertTree(arv,2,"Aveiro");

  printf("%d\n\n\n",TreeSize(arv));


  Preorder(arv,showentry);
  printf("\n\n");
  Inorder(arv,showentry);
  printf("\n\n");
  Postorder(arv,showentry);


  CopyTree(arv,&arv1);
  printf("\n\n");
  Postorder(arv1,showentry);
  arv1=InsertTree(arv1,10,"Beja");
  printf("\n\n");
  Postorder(arv,showentry);
  printf("\n\n");
  Postorder(arv1,showentry);

  ClearTree(&arv1);
  printf("\n\n");
  Postorder(arv1,showentry);

  printf("\n ----------- \n");
  arv1=TreeCopy(arv);

  arv1=InsertTree(arv1,10,"Beja");
  printf("\n\n");
  Postorder(arv,showentry);
  printf("\n\n");
  Postorder(arv1,showentry);



  printf("\n FIM\n");


  return 0;
}



void showkey(TreeEntry x)
{
  printf("%d\n",x.key);
}

void showentry(TreeEntry x)
{
  printf("%d   %s\n",x.key,x.name);
}
